#include <dataStreamTransferIS.h>
#include <string>
#include <fstream>
#include <time.h>

using namespace std;
using namespace dataStreamTransfer;

// get dataStream
ByteSeq FileStoreI::get(const string& filename, const ::Ice::Current&) {
  ifstream in(filename.c_str(),ios::binary);
  ifstream::pos_type size;
  in.seekg(0,ios::end);
  size=in.tellg();
  in.seekg(0,ios::beg);
  ByteSeq buffer(size);
  in.read(reinterpret_cast<char*>(&buffer[0]),size);
  in.close();
  return buffer;
};

// store dataStream
void FileStoreI::put(const string& filename, const ByteSeq& bytes, const ::Ice::Current&) {
  ofstream out;
  out.open(filename.c_str(),ios::out|ios::binary);
  size_t s=bytes.size();
  out.write((char*)(&bytes[0]),s*sizeof(bytes[0]));
  out.close();
};
// print String
void FileStoreI::printString(const string& value, const ::Ice::Current&) {
  cout << value << endl;
};
// set data Stream
void FileStoreI::setDataString(const string& value, const ::Ice::Current& c) {
  datatext dt;
  int startValue;
  // Leere die Abbildungen
  if(FileStoreI::_mapString.empty() == 1) {
    FileStoreI::_mapString.clear();
  }
  else {
    startValue = FileStoreI::_mapString.size()+1;
  }
  int count = startValue; 
  // Hole aktuelle Zeit
  time_t t = time(NULL);
  char* timeString = ctime(&t);
  string time = timeString;
  // Loesche das Newlinezeichen am Ende
  time.resize(time.size()-1);
  // Erstelle die Message
  stringstream ss;
  ss << count;
  string text = ss.str() + ":" 
    + value;
  // Einfuegen der Daten in die Datenbank 
  dt.time = time;
  dt.content = text;
  FileStoreI::_mapString.insert(make_pair(count,dt));
};
