#include <Ice/Ice.h>
#include <Freeze/Freeze.h>
#include <dataStreamTransfer.h>
#include <dataStreamTransferIS.h>

class dataStreamServer : virtual public Ice::Application {
public:
  dataStreamServer(const string& envName) : _envName(envName) {}
  
  int run(int argc, char* argv[]) {
      shutdownOnInterrupt();
      
      FileStoreI::_adapter = communicator()->createObjectAdapter("FileStore");

      FileStoreI::_communicator = communicator();
      FileStoreI::_envName = _envName;
      FileStoreI::_dbName = "string";

      Freeze::ConnectionPtr connection = Freeze::createConnection(communicator(), _envName);
      IntDatatextMap mapString(connection, FileStoreI::_dbName);
      FileStoreI::_mapString = mapString;
      
      Ice::ObjectPtr object = new FileStoreI;
      FileStoreI::_adapter->add(object,communicator()->stringToIdentity("SimpleLogFile"));
      FileStoreI::_adapter->activate();
      communicator()->waitForShutdown();
      if (interrupted()) {
	cerr << appName() << ": received signal, shutting down" << endl;
      }
    return 0;
  }
private:
  string _envName;
};

int main(int argc, char* argv[]) {
  dataStreamServer dss("db");
  return dss.main(argc,argv);
}
